<template>
  <div>
    <div id="container" style="background-color: #103c5d">
      <div class="section"></div>
      <div class="sectionBox">
        <!-- <el-radio-group
          v-model="radio"
          @change="handleChange"
        >
          <el-radio
            v-for='item in checkData'
            :label="item.name"
            :key='item.key'
          >{{item.name}}</el-radio>
        </el-radio-group> -->
        <el-tabs v-model="activeName" @tab-click="handleClick">
          <el-tab-pane label="桥梁" name="first">桥梁</el-tab-pane>
          <el-tab-pane label="隧道" name="second">隧道</el-tab-pane>
          <el-tab-pane label="边坡" name="third">边坡</el-tab-pane>
          <el-tab-pane label="涵洞" name="fourth">涵洞</el-tab-pane>
          <el-tab-pane label="沿线设施" name="five">沿线设施</el-tab-pane>
        </el-tabs>
        <el-button class="btn" type="primary" @click="openList"
          >{{ open == true ? '收起' : '展开' }}
          <i
            class="el-icon-arrow-up"
            :style="
              open == true
                ? 'transform: rotate(0deg)'
                : 'transform: rotate(180deg)'
            "
          ></i>
        </el-button>
      </div>
      <el-card
        class="card-box"
        :style="open == true ? '' : 'height: 0'"
        v-loading.fullscreen.lock="fullscreenLoading"
      >
        <el-form ref="searchForm" :model="searchForm" label-width="80px" class='searchTop'>
          <el-input
            v-if="type == '1'"
            v-model="searchForm.name"
            placeholder="请输入名称"
            style="margin-bottom: 10px; width: 190px"
            clearable
          ></el-input>
          <el-input
            v-if="type != '1'"
            v-model="searchForm.number"
            placeholder="请输入编号"
            style="margin-bottom: 10px; width: 190px"
          ></el-input>
          <el-select
            v-model="searchForm.roadSegmentName"
            placeholder="请选择路段"
            clearable
            filterable
            style="margin-left: 10px; width: 190px"
          >
            <el-option
              v-for="item in roadData"
              :key="item.key"
              :label="item.value"
              :value="item.value"
            >
            </el-option>
          </el-select>
          <el-button
            type="primary"
            icon="el-icon-search"
            circle
            @click="searCh"
            class="btnSerach"
          ></el-button>
        </el-form>
        <el-table :data="tableData" border style="width: 100%" @row-click="remark">
          <!-- <el-table-column
            prop="centPegK"
            label="桩号"
            align='center'
          >
          </el-table-column> -->
          <!-- 判断显示什么值 -->
          <el-table-column
            prop="name"
            :label="name"
            align="center"
            v-if="type == '1'"
            show-overflow-tooltip
          >
          </el-table-column>
          <el-table-column
            prop="protectType"
            :label="name"
            align="center"
            v-if="type == '2'"
            show-overflow-tooltip
          >
          </el-table-column>
          <el-table-column
            prop="number"
            :label="type == '3' ? '涵洞编号' : ''"
            align="center"
            v-if="type == '3'"
            show-overflow-tooltip
          >
          </el-table-column>
          <el-table-column
            prop="uses"
            :label="name"
            align="center"
            v-if="type == '3'"
            show-overflow-tooltip
          >
            <template v-slot="{row}" v-if="type == '3'">
              <div>{{ getDictName('yt', row.uses) }}</div>
            </template>
          </el-table-column>
          <el-table-column
            prop="direction"
            label="方向"
            align="center"
            :show-overflow-tooltip="true"
          >
            <template v-slot="{row}">
              <div>{{ getDictName('qlfx', row.direction) }}</div>
            </template>
          </el-table-column>
          <el-table-column
            prop="lng"
            label="横坐标"
            align="center"
            show-overflow-tooltip
          >
            <template slot-scope="scope">
              <el-input
                v-if="scope.row.show"
                v-model="scope.row.lng"
              ></el-input>
              <span v-if="!scope.row.show">{{ scope.row.lng }}</span>
            </template>
          </el-table-column>
          <el-table-column
            prop="lat"
            label="纵坐标"
            align="center"
            show-overflow-tooltip
          >
            <template slot-scope="scope">
              <el-input
                v-if="scope.row.show"
                v-model="scope.row.lat"
              ></el-input>
              <span v-if="!scope.row.show">{{ scope.row.lat }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center">
            <template slot-scope="scope">
              <el-button
                v-if="!scope.row.show"
                type="text"
                @click="edit(scope.row)"
                >修改</el-button
              >
              <el-button
                v-if="scope.row.show"
                type="text"
                @click="saveDate(scope.row)"
                >保存</el-button
              >
            </template>
          </el-table-column>
        </el-table>
      </el-card>
      <!-- 分页 -->
      <el-pagination
        v-show='open'
        class="pagination"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="currentPage"
        :page-sizes="[10, 50, 100, 200, 300, 400]"
        :page-size="pageSize"
        :pager-count="5"
        layout="total, sizes, prev, pager, next"
        :total="total"
      >
      </el-pagination>
    </div>
  </div>
</template>
<script>
import req from '@/request.js'
import basicData from '@/api/basicData.js'
const yhxt = window.context.yhxt
export default {
  name: 'MapToolManagement',
  data() {
    return {
      map: '',
      marker: '',
      radio: '桥梁',
      tableData: [],
      name: '桥梁名称',
      url: '/bizBridgeInformation/v1/getJson', //默认请求桥梁数据
      type: '1', //控制数据显示表头名称,1 代表是桥梁，隧道, 沿线设施，2 代表边坡， 3代表涵洞
      open: true, //控制是否是展开列表，默人展开
      marker: '', //点标记
      editObj: '', //暂存修改的数据
      value: '桥梁', //暂存用户点击复选框的名字用于判断保存的那一条数据
      fullscreenLoading: false,
      markers: [], //初始化是暂存点标记
      activeName: 'first',
      currentPage: 1, //分页
      pageSize: 10, //页面数据条数
      total: 0,
      pageBean: {
        page: 1,
        pageSize: 10,
        showTotal: true,
      },
      searchForm: {
        name: '',
        number: '',
        roadSegmentName: '',
      },
      roadData: [],
    }
  },
  created() {
    this.roadData = this.getroad()
    setTimeout(() => {
      // this.initMap()
    }, 1000)
    //默认第一次请求桥梁信息
    this.getData(this.url).then((res) => {
      console.log(res, 'map')
      this.total = res.total
      this.pageSize = res.pageSize
      this.currentPage = res.page
      this.tableData = res.rows
    })
  },
  watch: {
    iconStyle: function () {
      console.log(this.iconStyle)
    },
  },
  methods: {
    getroad() {
      let arr = []
      basicData.getRoadManagement().then((res) => {
        res.rows.forEach((item) => {
          arr.push({
            value: item.name,
            key: item.name,
          })
        })
        console.log(arr, '12')
      })
      return arr
    },
    //分页
    handleSizeChange(val) {
      console.log(1)
      this.pageBean.pageSize = val
      let obj = {}
      obj.pageBean = this.pageBean
      this.handleChange(this.value, obj)
      // console.log(`每页 ${val} 条`)
    },
    handleCurrentChange(val) {
      let query = []
      let search = {
        road_segment_name_: this.searchForm.roadSegmentName,
        name: this.searchForm.name,
        number: this.searchForm.number,
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i],
          })
        }
      }
      this.pageBean.page = val
      if (query.length == 0) {
        let obj = {}
        obj.pageBean = this.pageBean
        this.handleChange(this.value, obj)
      } else {
        let data = {
          pageBean: {
            page: val,
            pageSize: 10,
            showTotal: true,
          },
          querys: query,
        }
        this.handleChange(this.value, data)
      }
      // console.log(`当前页: ${val}`)
    },
    //tab栏切换事件
    handleClick(tab) {
      let value = tab.label
      this.handleChange(value)
    },
    // 标记地图坐标
    remark(obj) {
       //移除上一个标记点
       if (this.marker) {
        this.marker.setMap(null)
        this.marker = null
      }
      //扩展出x,lat
      let {lng: lng, lat: lat, name: name, id: id} = obj
      if (lng && lat) {
        this.locationMark(lng, lat, name)
        // }
      } else {
        //如果不存在默认一个坐标
        lng = 117.678805
        lat = 35.357825
        this.locationMark(lng, lat, name)
      }
    },
    //修改地图横纵坐标
    edit(obj) {
      //暂存修改的数据
      this.$set(obj, 'show', true)
      this.editObj = obj
      //移除上一个标记点
      if (this.marker) {
        this.marker.setMap(null)
        this.marker = null
      }
      //扩展出x,lat
      let {lng: lng, lat: lat, name: name, id: id} = obj
      if (lng && lat) {
        //  console.log(lng.indexOf('.'))
        // if (lng.indexOf('.') && lat.indexOf('.') != -1) {
        //   this.locationMark(lng, lat, name)
        // } else {
        //   lng = lng.slice(0, 3) + '.' + lng.slice(3)
        //   lat = lat.slice(0, 2) + '.' + lat.slice(2)
        this.locationMark(lng, lat, name)
        // }
      } else {
        //如果不存在默认一个坐标
        lng = 117.678805
        lat = 35.357825
        this.locationMark(lng, lat, name)
      }
    },
    //将获取的坐标标记到地图上
    locationMark(lng, lat, name) {
      let icon
      if (this.value == '桥梁') {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/qiaoliang.png'),
        })
      } else if (this.value == '隧道') {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/suidao.png'),
        })
      } else if (this.value == '边坡') {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/bianpo.png'),
        })
      } else if (this.value == '涵洞') {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/hanong.png'),
        })
      } else if (this.value == '沿线设施') {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/yanxiansheshi.png'),
        })
      } else {
        icon = new AMap.Icon({
          size: new AMap.Size(48, 48),
          image: require('../../assets/img/qiaoliang.png'),
          // imageSize: new AMap.Size(135, 40),
          // imageOffset: new AMap.Pixel(-8, -3)
        })
      }

      // 创建一个 Marker 实例：
      this.marker = new AMap.Marker({
        map: this.map,
        position: [lng, lat], // 经纬度对象，也可以是经纬度构成的一维数组[116.39, 39.9]
        offset: new AMap.Pixel(-13, -30),
        title: name,
        icon: icon,
      })
      // 将创建的点标记添加到已有的地图实例：
      this.map.add(this.marker)
      //定位导标记点
      this.map.setFitView()
      //设置图标移动
      // this.marker.setDraggable(true)
      //标记移动绑定事件
      // let amp = AMap.event.addListener
      // amp(this.marker, 'mouseup', (e) => {
      //   console.log(this.editObj)
      //   // console.log(e.lnglat)
      //   let lng = e.lnglat.lng //经度
      //   let lat = e.lnglat.lat //维度
      //   // console.log(this.editObj)
      //   //保存数据，保存之前给用户一个提示
      //   this.editObj.lng = lng
      //   this.editObj.lat = lat
      //   this.editObj.show = true
      //   // this.saveData(this.editObj)
      // })
      // let dvd=window.document.createElement('div')
      let info = []
      if (this.value == '桥梁') {
        info.push(
          "<div><p style='margin:10px 0'>桥梁编号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.number +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥梁名称 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.name +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>所在路段 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.roadSegmentName +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥梁类型 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.typeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥梁分类 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.categoryValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥梁方向 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.directionValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥面铺装 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.surfaceinstallValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桥梁长度 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.length +
            'm</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>跨径组合 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.spanCombo +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>上部结构类型 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.shapeTypeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>横坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lng +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>纵坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lat +
            '</span></p></div>'
        )
        console.log(info)
      } else if (this.value == '隧道') {
        info.push(
          "<div><p style='margin:10px 0'>隧道编号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.number +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>隧道名称 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.name +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>所在路段 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.roadSegmentName +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>隧道类型 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.typeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>隧道等级 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.gradeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>隧道方向 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.directionValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>入口形式 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.entranceFormValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>出口形式 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.exitFormValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>断面形式 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.surfaceLayValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>衬砌材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.onMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>洞身材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.bodyMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>横坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lng +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>纵坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lat +
            '</span></p></div>'
        )
      } else if (this.value == '边坡') {
        this.editObj.isHighRiskValue =
          this.editObj.isHighRisk == '1' ? '是' : '否'
        this.editObj.isRampValue = this.editObj.isRamp == '1' ? '是' : '否'
        info.push(
          "<div><p style='margin:10px 0'>边坡编号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.number +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>所在路段 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.roadSegmentName +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>起点桩号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.startPeg +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>止点桩号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.endPeg +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>边坡方向 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.directionValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>保护尺寸 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.protectiveDimension +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>是否高危边坡 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.isHighRiskValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>是否匝道结构物 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.isRampValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>保护种类 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.protectType +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>防护位置 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.geology +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>横坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lng +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>纵坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lat +
            '</span></p></div>'
        )
      } else if (this.value == '涵洞') {
        info.push(
          "<div><p style='margin:10px 0'>涵洞编号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.number +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>涵洞类型 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.typeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>所在路段 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.roadSegmentName +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>涵洞方向 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.directionValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>涵洞高度 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.height +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>涵洞长度 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.length +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>上层材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.topMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>身体材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.bodyMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>入口材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.entranceMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>出口材料 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.exitMaterialValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>入口形式 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.entranceFormValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>出口形式 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.exitFormValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>用途 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.usesValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>横坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lng +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>纵坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lat +
            '</span></p></div>'
        )
      } else if (this.value == '沿线设施') {
        info.push(
          "<div><p style='margin:10px 0'>沿线设施名称 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.name +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>所在路段 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.roadSegmentName +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>设施类型 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.typeValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>设施方向 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.directionValue +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>桩号 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.peg +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>横坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lng +
            '</span></p>'
        )
        info.push(
          "<p style='margin:10px 0'>纵坐标 : <span style='font-size:14px;font-weight:600'>" +
            this.editObj.lat +
            '</span></p></div>'
        )
      }
      this.marker.content = info
      let infoWindow = new AMap.InfoWindow({
        offset: new AMap.Pixel(0, -30),
        content: info.join(''),
      })
      this.marker.emit('click', {target: this.marker})
      this.marker.on('dblclick', (e) => {
        console.log(e)
        // infoWindow.setContent(e.target.content)
        infoWindow.open(this.map, e.target.getPosition())
      })
    },
    // //弹框
    // openBox(lng, lat) {
    //   console.log(this.editObj)
    //   this.$confirm('是否执行这项操作', '提示', {
    //     confirmButtonText: '确定',
    //     cancelButtonText: '取消',
    //     type: 'warning',
    //   })
    //     .then(() => {
    //       //保存数据
    //       //将修改之后的经纬度赋值到原来的数据
    //       this.editObj.lng = lng
    //       this.editObj.lat = lat
    //       this.saveData(this.editObj)
    //       this.$message({
    //         type: 'success',
    //         message: '修改成功!',
    //       })
    //     })
    //     .catch(() => {
    //       this.edit(this.editObj)
    //       this.$message({
    //         type: 'info',
    //         message: '已取消修改',
    //       })
    //     })
    // },
    //打开数据列表
    openList() {
      this.open = !this.open
    },
    //获取数据
    getData(url, data) {
      return new Promise((resolve, reject) => {
        req.post(yhxt + `${url}`, data).then(
          (resp) => {
            resolve(resp.data)
          },
          (error) => {
            reject(error)
          }
        )
      })
    },
    saveDate(row) {
      this.saveData(row)
      this.$set(row, 'show', false)
      //移除上一个标记点
      if (this.marker) {
        this.marker.setMap(null)
        this.marker = null
      }
      //扩展出x,lat
      let {lng: lng, lat: lat, name: name, id: id} = row
      if (lng && lat) {
        //  console.log(lng.indexOf('.'))
        // if (lng.indexOf('.') && lat.indexOf('.') != -1) {
        //   this.locationMark(lng, lat, name)
        // } else {
        //   lng = lng.slice(0, 3) + '.' + lng.slice(3)
        //   lat = lat.slice(0, 2) + '.' + lat.slice(2)
        this.locationMark(lng, lat, name)
        // }
      } else {
        //如果不存在默认一个坐标
        lng = 117.678805
        lat = 35.357825
        this.locationMark(lng, lat, name)
      }
    },
    //保存数据
    save(url, data) {
      return new Promise((resolve, reject) => {
        req.post(yhxt + `${url}`, data).then(
          (resp) => {
            resolve(resp.data)
          },
          (error) => {
            reject(error)
          }
        )
      })
    },
    saveData(data) {
      this.fullscreenLoading = true
      if (this.value == '桥梁') {
        this.save('/bizBridgeInformation/v1/saveBridge', data).then((res) => {
          // console.log(res)
          if (res.state) {
            this.$message.success(res.message)
          } else {
            this.$message.error('保存失败！')
          }
          this.fullscreenLoading = false
        })
      } else if (this.value == '隧道') {
        this.save('/bizTunnelInformation/v1/saveTunnel', data).then((res) => {
          // console.log(res)
          if (res.state) {
            this.$message.success(res.message)
          } else {
            this.$message.error('保存失败！')
          }
          this.fullscreenLoading = false
        })
      } else if (this.value == '边坡') {
        this.save('/bizSideSlopeInformation/v1/saveSideSlope', data).then(
          (res) => {
            // console.log(res)
            if (res.state) {
              this.$message.success(res.message)
            } else {
              this.$message.error('保存失败！')
            }
            this.fullscreenLoading = false
          }
        )
      } else if (this.value == '涵洞') {
        this.save(
          '/bizCulvertInformation/bizCulvertInformationmanager/v1/save',
          data
        ).then((res) => {
          // console.log(res)
          if (res.state) {
            this.$message.success(res.message)
          } else {
            this.$message.error('保存失败！')
          }
          this.fullscreenLoading = false
        })
      } else if (this.value == '沿线设施') {
        this.save(
          '/bizRoadsideFacilities/bizRoadsideFacilitiesManager/v1/save',
          data
        ).then((res) => {
          // console.log(res)
          if (res.state) {
            this.$message.success(res.message)
          } else {
            this.$message.error('保存失败！')
          }
          this.fullscreenLoading = false
        })
      }
    },
    //复选框改变事件，赋值请求名称
    handleChange(val, data) {
      //暂存名称便于保存数据时判断保存的是一条数据
      console.log(val, data)
      this.value = val
      if (val == '桥梁') {
        this.name = '桥梁名称'
        this.type = '1'
        this.getData('/bizBridgeInformation/v1/getJson', data).then((res) => {
          this.tableData = res.rows
          console.log(this.tableData)
          this.total = res.total
          this.pageSize = res.pageSize
          this.currentPage = res.page
        })
      } else if (val == '隧道') {
        this.name = '隧道名称'
        this.type = '1'
        this.getData('/bizTunnelInformation/v1/getJson', data).then((res) => {
          this.tableData = res.rows
          this.total = res.total
          this.pageSize = res.pageSize
          this.currentPage = res.page
        })
      } else if (val == '边坡') {
        this.name = '类型'
        this.type = '2'
        this.getData('/bizSideSlopeInformation/v1/getJson', data).then(
          (res) => {
            this.tableData = res.rows
            this.total = res.total
            this.pageSize = res.pageSize
            this.currentPage = res.page
          }
        )
      } else if (val == '涵洞') {
        this.name = '用途'
        this.type = '3'
        this.getData(
          '/bizCulvertInformation/bizCulvertInformationmanager/v1/getJson',
          data
        ).then((res) => {
          this.tableData = res.rows
          console.log(this.tableData, '涵洞')
          this.total = res.total
          this.pageSize = res.pageSize
          this.currentPage = res.page
        })
      } else if (val == '沿线设施') {
        this.name = '沿线设施名称'
        this.type = '1'
        this.getData(
          '/bizRoadsideFacilities/bizRoadsideFacilitiesManager/v1/getJson',
          data
        ).then((res) => {
          this.tableData = res.rows
          this.total = res.total
          this.pageSize = res.pageSize
          this.currentPage = res.page
        })
      }
    },
    //初始地图
    // initMap() {
    //   let map = new AMap.Map('container', {
    //     resizeEnable: true,
    //     draggable: true,
    //     mapStyle: 'amap://styles/darkblue', //地图主题
    //     // mapStyle:'amap://styles/260ac3de881fb752fdf854ea2b2540d8',
    //     zoom: 13, //地图显示的缩放级别
    //   })
    //   this.map = map
    // },
    //查找
    searCh() {
      let query = []
      let search = {
        road_segment_name_: this.searchForm.roadSegmentName,
        name: this.searchForm.name,
        number: this.searchForm.number,
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i],
          })
        }
      }
      let data = {
        pageBean: {
          page: 1,
          pageSize: 10,
          showTotal: true,
        },
        querys: query,
      }
      this.handleChange(this.value, data)
    },
    //初始化标记
    // initMarker() {
    //   // console.log(this.markers, 'dddddddddddddddddd')
    //   this.map.remove(this.markers);
    //   let icon = new AMap.Icon({
    //     size: new AMap.Size(53, 68),
    //     image:
    //       '//a.amap.com/jsapi_demos/static/demo-center/icons/poi-marker-default.png'
    //     // imageSize: new AMap.Size(135, 40),
    //     // imageOffset: new AMap.Pixel(-8, -3)
    //   })
    //   let markerList = []
    //   this.tableData.forEach(item => {
    //     let {lng: lng, lat: lat, name: name, id: id} = item
    //     if (lng && lat) {
    //       //  console.log(lng.slice(3),lng.slice(0,3))
    //       if (lng.indexOf('.') && lat.indexOf('.') != -1) {
    //         lng = lng
    //         lat = lat
    //       } else {
    //         lng = lng.slice(0, 3) + '.' + lng.slice(3)
    //         lat = lat.slice(0, 2) + '.' + lat.slice(2)
    //       }
    //     }
    //     markerList.push({
    //       map: this.map,
    //       position: [lng, lat], // 经纬度对象，也可以是经纬度构成的一维数组[116.39, 39.9]
    //       offset: new AMap.Pixel(-13, -30),
    //       title: name,
    //       icon: icon
    //     })
    //   })
    //   // console.log(markerList)
    //   markerList.forEach(item => {
    //     if (item.position[0] && item.position[1]) {
    //       this.markers.push(new AMap.Marker(item))
    //       this.map.add(new AMap.Marker(item))
    //     }
    //   })
    //   //定位到标记点
    //   this.map.setFitView()
    // }
    // handleAdd() {
    //   //自定义弹窗
    //   let infoWindow = new AMap.InfoWindow({
    //     isCustom: true, //使用自定义窗体
    //     offset: new AMap.Pixel(16, -45)
    //   })
    //   this.createInfoDom(infoWindow, this.name)
    // },
    // createInfoDom(infoWindow, item){//自定义弹框
    //   let Content = Vue.extend({//自定义模板继承
    //     template: `<base-info :propData="nameExtend"></base-info>`,
    //     name: 'child',
    //     components: {
    //       'base-info': info //弹框用子组件包裹
    //     },
    //     data(){
    //       return {
    //         nameExtend:item
    //       }
    //     }
    //   });

    //   let component = new Content().$mount();

    //   infoWindow.setContent(component.$el);
    //   infoWindow.open(this.map, [106.545566, 29.566804]);
    // }
  },
}
</script>
<style lang='scss' scoped>
#container {
  height: calc(100% + 10px);
  margin: 5px;
  position: relative;
  .sectionBox {
    position: absolute;
    top: 20px;
    left: 35px;
    z-index: 999;
    .btn {
      position: absolute;
      top: 5px;
      right: -122px;
      box-sizing: border-box;
    }
  }
  .section {
    position: absolute;
    height: 40px;
    width: 380px;
    top: 20px;
    left: 10px;
    z-index: 99;
    background-color: #114066;
    opacity: 0.9;
    border-radius: 10px;
  }
  .card-box {
    position: absolute;
    z-index: 999;
    width: 480px;
    top: 70px;
    left: 5px;
    height: calc(100% - 150px);
    overflow: auto;
    transition: all 0.3s;
  }
  .pagination {
    position: absolute;
    background-color: #114066;
    z-index: 999;
    bottom: 40px;
    left: 5px;
    width: 480px;
    padding: 0;
  }
}
.el-icon-arrow-up {
  transition: all 0.5s;
  margin-left: 5px;
}
.iconRoate_0deg {
  transform: rotate(0deg);
}
.iconRoate_180deg {
  transform: rotate(180deg);
}
.searchTop {
  height: 40px;
  line-height: 40px;
  margin-left: 5px;
}
.btnSerach {
  width: 40px;
  border-radius: 10%;
}
/deep/ .el-tabs__item,
/deep/ .el-pager li.btn-quicknext {
  color: #fff;
}
/deep/ .el-table th.is-leaf,
/deep/ .el-pager li {
  background-color: #114066;
}
/deep/ .el-table--border {
  border: none;
}
/deep/ .el-card__body {
  padding: 0 !important;
}
</style>